<template>
  <div
    class="flex items-center p-5 mx-auto login-container"
    :style="{
      'background-image': 'url(' + backgroupdImageForm.ImagePath + ')',
    }"
  >
    <div class="w-full">
      <div class="flex justify-center w-full">
        <img class="w-[200px]" :src="logo.ImagePath" alt="" />
      </div>
      <el-form
        ref="loginFormRef"
        label-position="top"
        :model="loginFormData"
        :rules="loginRules"
        :validate-on-rule-change="false"
        class="w-full mx-auto"
      >
        <el-form-item :label="$t('username')" prop="Username">
          <el-input
            v-model="loginFormData.Username"
            :placeholder="$t('username')"
            type="text"
          />
        </el-form-item>
        <el-form-item :label="$t('password')" prop="Password">
          <el-input
            v-model="loginFormData.Password"
            show-password
            :placeholder="$t('password')"
            type="password"
          />
        </el-form-item>
        <el-form-item class="forgot-password-form-item">
          <auth-forgot-password-modal :fullscreen="true" />
        </el-form-item>
        <el-button
          :disabled="isLoginProccessing"
          type="danger"
          class="w-full"
          round
          @click="submitLogin(loginFormRef)"
          >{{ $t("submit") }}</el-button
        >
      </el-form>
    </div>
  </div>
</template>

<script lang="ts">
import useLogin from "@/composables/useLogin";
import themePropertiesHelper from "@/utils/themePropertyHelper";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { store } from "@/store";

export default defineComponent({
  name: "Login",
  setup() {
    const {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
    } = useLogin();
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const backgroupdImageForm = computed(
      (): IThemePropertiesFromApi =>
        themePropertiesHelper.getSingleThemeProperty(
          themeProperties.value,
          "background_image_form"
        )
    );
    const logo = computed(
      (): IThemePropertiesFromApi =>
        themePropertiesHelper.getSingleThemeProperty(
          themeProperties.value,
          "logo"
        )
    );
    return {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      backgroupdImageForm,
      logo,
    };
  },
});
</script>
<style scoped>
.text-primary {
  color: var(--primary);
}

.login-container {
  height: 100vh;
  width: 100%;
}

:deep(button.el-button) {
  height: 42px;
  background-color: var(--primary);
  border: none;
}

:deep(.el-input__inner) {
  height: 48px;
  border-radius: 8px;
}

:deep(.el-button span) {
  @apply text-sm font-bold leading-4;
}

:deep(.forgot-form__logo) {
  height: unset;
}
</style>
